import{s as oe,o as re,n as se}from"../chunks/scheduler.00bde567.js";import{S as me,i as fe,g as d,s as a,r as f,A as ce,h as o,f as l,c as n,j as ne,u as c,x as r,k as de,y as he,a as i,v as h,d as p,t as u,w as y}from"../chunks/index.752e2ff6.js";import{T as pe}from"../chunks/Tip.6fda87e9.js";import{C as Ut}from"../chunks/CodeBlock.e62cd1dc.js";import{H as O}from"../chunks/Heading.476d3364.js";function ue(tt){let s,$=`This API will load the model into memory on the <code>meta</code> device, so we are not actually downloading
and loading the full weights of the model into memory, nor do we need to. As a result it’s
perfectly fine to measure 8 billion parameter models (or more), without having to worry about
if your CPU can handle it!`;return{c(){s=d("p"),s.innerHTML=$},l(m){s=o(m,"P",{"data-svelte-h":!0}),r(s)!=="svelte-1byyf03"&&(s.innerHTML=$)},m(m,Q){i(m,s,Q)},p:se,d(m){m&&l(s)}}}function ye(tt){let s,$,m,Q,w,et,b,Zt="One very difficult aspect when exploring potential models to use on your machine is knowing just how big of a model will <em>fit</em> into memory with your current graphics card (such as loading the model onto CUDA).",lt,T,zt=`To help alleviate this, 🤗 Accelerate has a CLI interface through <code>accelerate estimate-memory</code>. This tutorial will
help walk you through using it, what to expect, and at the end link to the interactive demo hosted on the 🤗 Hub which will
even let you post those results directly on the model repo!`,it,v,At="Currently we support searching for models that can be used in <code>timm</code> and <code>transformers</code>.",at,M,nt,L,dt,g,Yt=`When using <code>accelerate estimate-memory</code>, you need to pass in the name of the model you want to use, potentially the framework
that model utilizing (if it can’t be found automatically), and the data types you want the model to be loaded in with.`,ot,H,jt="For example, here is how we can calculate the memory footprint for <code>bert-base-cased</code>:",rt,B,st,_,Ft=`This will download the <code>config.json</code> for <code>bert-based-cased</code>, load the model on the <code>meta</code> device, and report back how much space
it will use:`,mt,x,Xt="Memory Usage for loading <code>bert-base-cased</code>:",ft,C,Nt="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>84.95 MB</td> <td>418.18 MB</td> <td>1.61 GB</td></tr> <tr><td>float16</td> <td>42.47 MB</td> <td>206.59 MB</td> <td>826.36 MB</td></tr> <tr><td>int8</td> <td>21.24 MB</td> <td>103.29 MB</td> <td>413.18 MB</td></tr> <tr><td>int4</td> <td>10.62 MB</td> <td>51.65 MB</td> <td>206.59 MB</td></tr></tbody>",ct,G,Et="By default it will return all the supported dtypes (<code>int4</code> through <code>float32</code>), but if you are interested in specific ones these can be filtered.",ht,P,pt,W,Jt=`If the source library cannot be determined automatically (like it could in the case of <code>bert-base-cased</code>), a library name can
be passed in.`,ut,k,yt,S,Vt="Memory Usage for loading <code>HuggingFaceM4/idefics-80b-instruct</code>:",Mt,U,qt="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>3.02 GB</td> <td>297.12 GB</td> <td>1.16 TB</td></tr> <tr><td>float16</td> <td>1.51 GB</td> <td>148.56 GB</td> <td>594.24 GB</td></tr> <tr><td>int8</td> <td>772.52 MB</td> <td>74.28 GB</td> <td>297.12 GB</td></tr> <tr><td>int4</td> <td>386.26 MB</td> <td>37.14 GB</td> <td>148.56 GB</td></tr></tbody>",$t,Z,wt,z,It="Memory Usage for loading <code>timm/resnet50.a1_in1k</code>:",bt,A,Rt="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>9.0 MB</td> <td>97.7 MB</td> <td>390.78 MB</td></tr> <tr><td>float16</td> <td>4.5 MB</td> <td>48.85 MB</td> <td>195.39 MB</td></tr> <tr><td>int8</td> <td>2.25 MB</td> <td>24.42 MB</td> <td>97.7 MB</td></tr> <tr><td>int4</td> <td>1.12 MB</td> <td>12.21 MB</td> <td>48.85 MB</td></tr></tbody>",Tt,Y,vt,j,Dt="As mentioned earlier, while we return <code>int4</code> through <code>float32</code> by default, any dtype can be used from <code>float32</code>, <code>float16</code>, <code>int8</code>, and <code>int4</code>.",Lt,F,Qt="To do so, pass them in after specifying <code>--dtypes</code>:",gt,X,Ht,N,Ot="Memory Usage for loading <code>bert-base-cased</code>:",Bt,E,Kt="<thead><tr><th>dtype</th> <th>Largest Layer</th> <th>Total Size</th> <th>Training using Adam</th></tr></thead> <tbody><tr><td>float32</td> <td>84.95 MB</td> <td>413.18 MB</td> <td>1.61 GB</td></tr> <tr><td>float16</td> <td>42.47 MB</td> <td>206.59 MB</td> <td>826.36 MB</td></tr></tbody>",_t,J,xt,V,te="This calculator will tell you how much memory is needed to purely load the model in, <em>not</em> to perform inference.",Ct,q,ee="This calculation is accurate within a few % of the actual value, so it is a very good view of just how much memory it will take. For instance loading <code>bert-base-cased</code> actually takes <code>413.68 MB</code> when loaded on CUDA in full precision, and the calculator estimates <code>413.18 MB</code>.",Gt,I,le=`When performing inference you can expect to add up to an additional 20% as found by <a href="https://blog.eleuther.ai/transformer-math/" rel="nofollow">EleutherAI</a>. We’ll be conducting research into finding a more accurate estimate to these values, and will update
this calculator once done.`,Pt,R,Wt,D,ie=`Lastly, we invite you to try the <a href="https://huggingface.co/spaces/hf-accelerate/model-memory-usage" rel="nofollow">live Gradio demo</a> of this utility,
which includes an option to post a discussion thread on a models repository with this data. Doing so will help provide access to these numbers in the community faster and help users know what you’ve learned!`,kt,K,St;return w=new O({props:{title:"Understanding how big of a model can fit on your machine",local:"understanding-how-big-of-a-model-can-fit-on-your-machine",headingTag:"h1"}}),M=new pe({props:{$$slots:{default:[ue]},$$scope:{ctx:tt}}}),L=new O({props:{title:"The Command",local:"the-command",headingTag:"h2"}}),B=new Ut({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMGJlcnQtYmFzZS1jYXNlZA==",highlighted:"accelerate estimate-memory bert-base-cased",wrap:!1}}),P=new O({props:{title:"Specific libraries",local:"specific-libraries",headingTag:"h3"}}),k=new Ut({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMEh1Z2dpbmdGYWNlTTQlMkZpZGVmaWNzLTgwYi1pbnN0cnVjdCUyMC0tbGlicmFyeV9uYW1lJTIwdHJhbnNmb3JtZXJz",highlighted:"accelerate estimate-memory HuggingFaceM4/idefics-80b-instruct --library_name transformers",wrap:!1}}),Z=new Ut({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMHRpbW0lMkZyZXNuZXQ1MC5hMV9pbjFrJTIwLS1saWJyYXJ5X25hbWUlMjB0aW1t",highlighted:"accelerate estimate-memory timm/resnet50.a1_in1k --library_name timm",wrap:!1}}),Y=new O({props:{title:"Specific dtypes",local:"specific-dtypes",headingTag:"h3"}}),X=new Ut({props:{code:"YWNjZWxlcmF0ZSUyMGVzdGltYXRlLW1lbW9yeSUyMGJlcnQtYmFzZS1jYXNlZCUyMC0tZHR5cGVzJTIwZmxvYXQzMiUyMGZsb2F0MTY=",highlighted:"accelerate estimate-memory bert-base-cased --dtypes float32 float16",wrap:!1}}),J=new O({props:{title:"Caveats with this calculator",local:"caveats-with-this-calculator",headingTag:"h2"}}),R=new O({props:{title:"Live Gradio Demo",local:"live-gradio-demo",headingTag:"h2"}}),{c(){s=d("meta"),$=a(),m=d("p"),Q=a(),f(w.$$.fragment),et=a(),b=d("p"),b.innerHTML=Zt,lt=a(),T=d("p"),T.innerHTML=zt,it=a(),v=d("p"),v.innerHTML=At,at=a(),f(M.$$.fragment),nt=a(),f(L.$$.fragment),dt=a(),g=d("p"),g.innerHTML=Yt,ot=a(),H=d("p"),H.innerHTML=jt,rt=a(),f(B.$$.fragment),st=a(),_=d("p"),_.innerHTML=Ft,mt=a(),x=d("p"),x.innerHTML=Xt,ft=a(),C=d("table"),C.innerHTML=Nt,ct=a(),G=d("p"),G.innerHTML=Et,ht=a(),f(P.$$.fragment),pt=a(),W=d("p"),W.innerHTML=Jt,ut=a(),f(k.$$.fragment),yt=a(),S=d("p"),S.innerHTML=Vt,Mt=a(),U=d("table"),U.innerHTML=qt,$t=a(),f(Z.$$.fragment),wt=a(),z=d("p"),z.innerHTML=It,bt=a(),A=d("table"),A.innerHTML=Rt,Tt=a(),f(Y.$$.fragment),vt=a(),j=d("p"),j.innerHTML=Dt,Lt=a(),F=d("p"),F.innerHTML=Qt,gt=a(),f(X.$$.fragment),Ht=a(),N=d("p"),N.innerHTML=Ot,Bt=a(),E=d("table"),E.innerHTML=Kt,_t=a(),f(J.$$.fragment),xt=a(),V=d("p"),V.innerHTML=te,Ct=a(),q=d("p"),q.innerHTML=ee,Gt=a(),I=d("p"),I.innerHTML=le,Pt=a(),f(R.$$.fragment),Wt=a(),D=d("p"),D.innerHTML=ie,kt=a(),K=d("p"),this.h()},l(t){const e=ce("svelte-u9bgzb",document.head);s=o(e,"META",{name:!0,content:!0}),e.forEach(l),$=n(t),m=o(t,"P",{}),ne(m).forEach(l),Q=n(t),c(w.$$.fragment,t),et=n(t),b=o(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1qyhu4i"&&(b.innerHTML=Zt),lt=n(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-rqomdz"&&(T.innerHTML=zt),it=n(t),v=o(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-w4272k"&&(v.innerHTML=At),at=n(t),c(M.$$.fragment,t),nt=n(t),c(L.$$.fragment,t),dt=n(t),g=o(t,"P",{"data-svelte-h":!0}),r(g)!=="svelte-45l1al"&&(g.innerHTML=Yt),ot=n(t),H=o(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-h4f2xa"&&(H.innerHTML=jt),rt=n(t),c(B.$$.fragment,t),st=n(t),_=o(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-ils653"&&(_.innerHTML=Ft),mt=n(t),x=o(t,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1nfe19i"&&(x.innerHTML=Xt),ft=n(t),C=o(t,"TABLE",{"data-svelte-h":!0}),r(C)!=="svelte-1555s6h"&&(C.innerHTML=Nt),ct=n(t),G=o(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1yqm0m1"&&(G.innerHTML=Et),ht=n(t),c(P.$$.fragment,t),pt=n(t),W=o(t,"P",{"data-svelte-h":!0}),r(W)!=="svelte-njwxoj"&&(W.innerHTML=Jt),ut=n(t),c(k.$$.fragment,t),yt=n(t),S=o(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-15w8ahh"&&(S.innerHTML=Vt),Mt=n(t),U=o(t,"TABLE",{"data-svelte-h":!0}),r(U)!=="svelte-18sp6z1"&&(U.innerHTML=qt),$t=n(t),c(Z.$$.fragment,t),wt=n(t),z=o(t,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1mr9yqw"&&(z.innerHTML=It),bt=n(t),A=o(t,"TABLE",{"data-svelte-h":!0}),r(A)!=="svelte-1kjhg7d"&&(A.innerHTML=Rt),Tt=n(t),c(Y.$$.fragment,t),vt=n(t),j=o(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-15o0uxk"&&(j.innerHTML=Dt),Lt=n(t),F=o(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-9rym4t"&&(F.innerHTML=Qt),gt=n(t),c(X.$$.fragment,t),Ht=n(t),N=o(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1nfe19i"&&(N.innerHTML=Ot),Bt=n(t),E=o(t,"TABLE",{"data-svelte-h":!0}),r(E)!=="svelte-1hk5v9f"&&(E.innerHTML=Kt),_t=n(t),c(J.$$.fragment,t),xt=n(t),V=o(t,"P",{"data-svelte-h":!0}),r(V)!=="svelte-gbqkuz"&&(V.innerHTML=te),Ct=n(t),q=o(t,"P",{"data-svelte-h":!0}),r(q)!=="svelte-wpwqvl"&&(q.innerHTML=ee),Gt=n(t),I=o(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1x4mgsf"&&(I.innerHTML=le),Pt=n(t),c(R.$$.fragment,t),Wt=n(t),D=o(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-tjk9os"&&(D.innerHTML=ie),kt=n(t),K=o(t,"P",{}),ne(K).forEach(l),this.h()},h(){de(s,"name","hf:doc:metadata"),de(s,"content",Me)},m(t,e){he(document.head,s),i(t,$,e),i(t,m,e),i(t,Q,e),h(w,t,e),i(t,et,e),i(t,b,e),i(t,lt,e),i(t,T,e),i(t,it,e),i(t,v,e),i(t,at,e),h(M,t,e),i(t,nt,e),h(L,t,e),i(t,dt,e),i(t,g,e),i(t,ot,e),i(t,H,e),i(t,rt,e),h(B,t,e),i(t,st,e),i(t,_,e),i(t,mt,e),i(t,x,e),i(t,ft,e),i(t,C,e),i(t,ct,e),i(t,G,e),i(t,ht,e),h(P,t,e),i(t,pt,e),i(t,W,e),i(t,ut,e),h(k,t,e),i(t,yt,e),i(t,S,e),i(t,Mt,e),i(t,U,e),i(t,$t,e),h(Z,t,e),i(t,wt,e),i(t,z,e),i(t,bt,e),i(t,A,e),i(t,Tt,e),h(Y,t,e),i(t,vt,e),i(t,j,e),i(t,Lt,e),i(t,F,e),i(t,gt,e),h(X,t,e),i(t,Ht,e),i(t,N,e),i(t,Bt,e),i(t,E,e),i(t,_t,e),h(J,t,e),i(t,xt,e),i(t,V,e),i(t,Ct,e),i(t,q,e),i(t,Gt,e),i(t,I,e),i(t,Pt,e),h(R,t,e),i(t,Wt,e),i(t,D,e),i(t,kt,e),i(t,K,e),St=!0},p(t,[e]){const ae={};e&2&&(ae.$$scope={dirty:e,ctx:t}),M.$set(ae)},i(t){St||(p(w.$$.fragment,t),p(M.$$.fragment,t),p(L.$$.fragment,t),p(B.$$.fragment,t),p(P.$$.fragment,t),p(k.$$.fragment,t),p(Z.$$.fragment,t),p(Y.$$.fragment,t),p(X.$$.fragment,t),p(J.$$.fragment,t),p(R.$$.fragment,t),St=!0)},o(t){u(w.$$.fragment,t),u(M.$$.fragment,t),u(L.$$.fragment,t),u(B.$$.fragment,t),u(P.$$.fragment,t),u(k.$$.fragment,t),u(Z.$$.fragment,t),u(Y.$$.fragment,t),u(X.$$.fragment,t),u(J.$$.fragment,t),u(R.$$.fragment,t),St=!1},d(t){t&&(l($),l(m),l(Q),l(et),l(b),l(lt),l(T),l(it),l(v),l(at),l(nt),l(dt),l(g),l(ot),l(H),l(rt),l(st),l(_),l(mt),l(x),l(ft),l(C),l(ct),l(G),l(ht),l(pt),l(W),l(ut),l(yt),l(S),l(Mt),l(U),l($t),l(wt),l(z),l(bt),l(A),l(Tt),l(vt),l(j),l(Lt),l(F),l(gt),l(Ht),l(N),l(Bt),l(E),l(_t),l(xt),l(V),l(Ct),l(q),l(Gt),l(I),l(Pt),l(Wt),l(D),l(kt),l(K)),l(s),y(w,t),y(M,t),y(L,t),y(B,t),y(P,t),y(k,t),y(Z,t),y(Y,t),y(X,t),y(J,t),y(R,t)}}}const Me='{"title":"Understanding how big of a model can fit on your machine","local":"understanding-how-big-of-a-model-can-fit-on-your-machine","sections":[{"title":"The Command","local":"the-command","sections":[{"title":"Specific libraries","local":"specific-libraries","sections":[],"depth":3},{"title":"Specific dtypes","local":"specific-dtypes","sections":[],"depth":3}],"depth":2},{"title":"Caveats with this calculator","local":"caveats-with-this-calculator","sections":[],"depth":2},{"title":"Live Gradio Demo","local":"live-gradio-demo","sections":[],"depth":2}],"depth":1}';function $e(tt){return re(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ge extends me{constructor(s){super(),fe(this,s,$e,ye,oe,{})}}export{ge as component};
